***********************************************************        
*                   AXIOM  CMD11A8
*
* Cr le    :  06/01/1999
* Modifi le :  22/12/1999  (dernire version :  le 07/01/2000)
* Auteur     :  POULIN Jean-Michel  (Modification : MISTRETTA Eric) 
*
* Programme rcrit les 06, 07 et 09/11/2007                
***********************************************************
		OPT		1
 
STACKS	EQU		$23FF			* Dbut de la pile valid pour un systme embarqu
 
        ORG     $8000			* Variable situ en RAM

* Variables situes en RAM
PORTA	EQU		$1000			* Port d'adresse du port A
LCDBAS  EQU     $B5F0           * Port d'adresse de l'afficheur   
KEYBAS  EQU     $B5F4           * Port d'adresse du clavier 
IO		EQU 	$93             * Registre de contrle du port d'adresse du clavier
NULL    EQU 	$00             * Dsigne la fin d'une chaine de caractres 
       

VALLSB	 RMW	1				* Words should be on even boundary for portability
VALMSB	 RMW	1	
COUNT	 RMW	1
LSB		 RMW	1 
MSB		 RMW	1
BUF1	 RMB	1				* Stockage de donne temporaire
BUF2	 RMB	1
BUF3	 RMB	1 	   
BUF4	 RMB	1
BUF5	 RMB	1
TAMP	 RMB	1
CYCLE1	 RMB	1 	   
FLAGS	 RMB	1				* Drapeau donnant la position de la vanne
AUT_OUV	 RMB	1				* Drapeau autorisant l'ouverture de la vanne selon l'tat du vide
LOC_DIS	 RMB	1				* Drapeau dfiniisant la position de la cl LOCAL/DISTANCE
UNE_FOIS RMB	1 	   			* Drapeau indiquant le dernier bouton poussoir appuy
SECU	 RMB	1	   			* Compteur vitant de rester en attente de positionnement de vanne si problme
	   

* Dbut Adresse

		ORG		$E000			* dbut du code adresse E000h pour un fonctionnement embarqu
 
		JMP		MAIN			* Saut vers la zone de donnes du programme principal
 
 
MSG1  	FCC     "Vanne VSC703 ouverte"        
        FCB     NULL
MSG2	FCC     "Vanne VSC703 fermee "
        FCB     NULL
MSG3  	FCC     "  Vide/pression OK  "        
        FCB     NULL
MSG4	FCC     "Defaut vide/pression"
        FCB     NULL
MSG5  	FCC     "      DISTANCE      "        
        FCB     NULL
MSG6	FCC     "       LOCAL        "
        FCB     NULL		
MSG7  	FCC     " Nbre cycles: "        
        FCB     NULL


TABLE	FCB		$31,$32,$33,$34		* Visualisation de la table de la matrice du clavier
		FCB		$35,$36,$37,$38
		FCB		$39,$41,$42,$43
		FCB		$44,$45,$46,$30

***********************************************************************************************	
* Dbut du programme principal  
***********************************************************************************************
MAIN
		SEI
		LDS		STACKBS			* Validation du pointeur, ne pas utiliser en mode buffalo
		
		LDAB	#1	
		STAB	AUT_OUV			* AUT_OUV = 1  : autorisation d'ouverture de la vanne

		LDAA	#0				
		STAA	FLAGS			* FLAGS = 0    : signalisation de vanne ferme
		
		STAA	UNE_FOIS		* UNE_FOIS = 0 : simule le dernier appui sur BP fermeture
		
		STAA	UNE_FOIS		* SECU = 0     : compteur de scurit initialis  0
		
		LDD		#0000
		STD		COUNT			* COUNT = 0    : compteur de cyles initialis  0	
		
		
********** Attente pour l'tablissement de l'alimentation de l'afficheur **********		
		LDX		#20
INIT_DELAY		
		BRN		INIT_DELAY
		DEX
        BNE     INIT_DELAY
        
		JSR		LCDSET			* Initialisation de l'afficheur LCD
		JSR		KEYSET			* Initialisation du clavier

					********************
********** Boucle permanente du programme principal ********** 

KEYIN
		JSR		BV_MV				* Contrle de l'tat du vide (bon vide/mauvais vide)
		JSR		VANVID				* Vrification de la position de la vanne pneumatique
		JSR		LOCAL_DISTANCE		* Vrification de la position de la cl LOCAL/DISTANCE
		JSR		DURVIE				* Affichage du nombre de cycles de fonctionnement

KEYSEC								* Branchement en cas de problme en attente (voir SECFIN)

		LDY		#KEYBAS				* get keypad port address
		CLR		BUF4				* clear counter
		LDAA	#$10				* start with First Row
		
LOP		CLR		$02,Y				* clear scan lines
        LDAB    $00,Y				* read keypad
		ANDB	#$F0				* mask all but data
        STAB    BUF1				* save result
		
		STAA	$02,Y				* send row scan
		LDAB	$00,Y				* read keypad
		ANDB	#$F0				* mask result
		CMPB	BUF1				* is there activity on this row ?
        BNE		DONE				* branch if yes

		LSLA						* no key here, shift for next Row
		ANDA	#$F0				* mask row counter for test
		BEQ		KEYIN				* if all rows scanned, start over
		
		INC		BUF4				* incriment index counter
		INC		BUF4
		INC		BUF4
		INC		BUF4
		BRA		LOP					* go scann new row
		
		
********** here if something is pressed, find the column **********
DONE	CLR		BUF3				* clear column counter
		STAB    BUF2				* save row data
LL      ANDB 	#$10				* get row number
		LDA		BUF1				* get column number
		ANDA	#$10
		CBA							* match found ?
		BNE		FOUND				* branch if yes
		INC		BUF3				* incriment counter
		LSR		BUF1				* shift for next column
		LSR		BUF2				* shift for next row
		LDAB	BUF2				* get row data
		BNE		LL					* go check next
		
********** si une touche a t presse, passage  FOUND **********
FOUND	CMPA	BUF5				* same key as pressed last time ?
		BEQ		DD					* branch if no
		STAA	BUF5				* save key for debounce
		JMP		KEYIN				* ANTI REBOND
		
DD		LDD		#TABLE				* load look up table
		ADDB	BUF3				* add column index
		ADDB	BUF4				* add row index
		XGDY						* prepare for table read
		LDAA	0,Y					* get the table data at this location 		
		
********** action sur la vanne selon le bouton poussoir press **********
APRES	LDAB	#0

		CMPB	AUT_OUV				* Si AUT_OUV=0, pas d'autorisation d'ouverture
		BEQ		FIN					*  et actions sur les poussoirs non prises en compte
		CMPB	LOC_DIS				* Si LOC_DIS=0 (cl en DISTANCE), actions
		BEQ		FIN					*  sur les poussoirs non prises en compte
		
        ********** test pour viter de compter plusieurs cycles conscutifs **********		
		LDAB	UNE_FOIS			* Comparaison de UNE_FOIS et FLAGS : si diffrents, alors vanne
		CMPB	FLAGS				*  en position intermdiaire et comptage plusieurs cycles possible
		BNE		SECFIN				* Dans ce cas, nouveau passage par BP1/BP2 vit : pas d'autre cycle compt
		****
	
BP1		CMPA	#$31				* BP ouverture (#31) appuy ?
		BNE		BP2					* Si non, branchement  BP2
		LDAB	#1
		CMPB	FLAGS				* Comparaison de l'accu. B avec FLAGS 
		BEQ		FIN					* Si FLAGS=1 (vanne ouverte), pas de dcompte
		JSR		DECADE				* Si FLAGS=0 (vanne ferm), dcompte de l'ouverture
        LDX		#PORTA
		BSET	0,X %00100000		* Ouverture vanne (PA5=1)
		LDAB	#1					* Remise  1 de l'accu. B modifi par l'appel  DECADE
		STAB    UNE_FOIS			* UNE_FOIS=1 (B=1), indique BP ouverture a dj t appuy
        JMP		FIN

BP2		CMPA	#$32				* BP fermeture (#32) appuy ?
		BNE		FIN					* Si non, branchement  FIN
		LDAB	#0					
		CMPB	FLAGS				* Comparaison de l'accu. B avec FLAGS 
		BEQ		FIN					* Si FLAGS=1 (vanne ferm), pas de dcompte
		JSR		DECADE				* Si FLAGS=0 (vanne ouverte), dcompte de la fermeture
        LDX		#PORTA
		BCLR	0,X %00100000		* Fermeture vanne (PA5=0)
		LDAB	#0					* Remise  0 de l'accu. B modifi par l'appel  DECADE
		STAB    UNE_FOIS			* UNE_FOIS=0, indique BP fermeture appuy en dernier
		
SECFIN	INC		SECU				* Boucle de scurit permettant de ne pas rester indfiniment
		LDAB	#10					*  en attente de changement d'tat de FLAGS si la vanne se
		CMPB	SECU				*  bloque en position intermdiaire ou si les cbles sont coups.
		BNE		FIN					*  Dans ces deux cas, FLAGS=0 et la vanne est considre ferme,
		LDAB	#1					*  d'o impossibilit de fermer avec le BP.
		STAB    UNE_FOIS			* Si attente trop longue :
		STAB    FLAGS				*  SECU arrive  10, UNE_FOIS et FLAGS sont mis  1 (vanne
		STAB    SECU				*  ouverte simule) et la fermeture est ainsi autorise en
		JMP		KEYSEC				*  vitant le passage par VANVID qui modifierait FLAGS.
		
FIN		JSR		DELAY				* Fin de la boucle permanente.
		JMP		KEYIN
		
					********************
		
		
*****************************************************************************	
*          Dcade du compteur  
*****************************************************************************
DECADE	
		LDD		COUNT				* Si le compteur est infrieur  99 (63 hexa.),
		CMPB	#$63				* sa valeur incrmente de 1 reste 
		BLO		OKNBR1				* contenue dans l'accu B: 00  XX  (valeur du compteur XX = 99 max.)
		CLRB						*                         A    B 
		ADDA	#$1					* Si le compteur est gal  99, sa valeur incrmente de 1 est crite
		JMP		ENCORE				* sur les deux accus par la mise  0 de l'accu B et l'incrment de 1
OKNBR1	ADD		#$1					* de l'accu A, par ex.:  00 99 -> 01 00 (puis 01 99 -> 02 00, etc...)
ENCORE	STD		COUNT				*                        A   B    A   B       A   B    A   B

		RTS

*****************************************************************************	
*          Etat Position Vanne VO/VF  
*****************************************************************************
VANVID
		LDX		#PORTA				* Vrification de l'tat de PA0:
		LDAA	#01					*   si PA0=1, vanne ferme // si PA0=0, vanne ouverte
		BITA	0,X					* BITA: ET bit  bit, Z(CCR)=1 si rsultat du ET est nul (soit PA0=0)
		BEQ		V_O					* Si PA0 est  0, branchement  V_O (BEQ: test de Z du CCR, branch. si Z=1)
										
		LDAA	#0
		STAA	FLAGS				* FLAGS=0 (vanne ferme)
		
		LDX		#MSG2				* Message " Vanne VSC 703 fermee "
		LDAB    #$C0				* Chargement de l'adresse
		STAB 	LCDBAS				*    d'affichage (2 ligne = $C0)
        JSR     LCDOUT				* Envoi  l'afficheur
		
		JMP		V_F
		
V_O
		LDAA	#1
		STAA	FLAGS				* FLAGS=1 (vanne ouverte)
		
		LDX		MSG1				* Message " Vanne VSC 703 ouverte "
		LDAB	#$C0				* Chargement de l'adresse
		STAB 	LCDBAS				*    d'affichage (2 ligne = $C0)
        JSR     LCDOUT				* Envoi  l'afficheur
	
V_F		JSR		DELAY
		RTS
	

*****************************************************************************	
*          Etat Bon(ne) vide/pression ou Mauvais(e) vide/pression  
*****************************************************************************	
BV_MV	
		LDX		#PORTA				* Vrification de l'tat de PA1:
		LDAA	#02					*   si PA1=1 dfaut vide/pression // si PA1=0: vide/pression ok
		BITA	0,X					* BITA: ET bit  bit, Z(CCR)=1 si rsultat du ET est nul (soit PA1=0)
		BEQ		B_V					* Si PA1 est  0, branchement  B_V (BEQ: test de Z du CCR, branch. si Z=1)

		LDX		#MSG4				* Message " Defaut vide/pression "
		LDAB    #$80				* Chargement de l'adresse
		STAB 	LCDBAS				*    d'affichage (1 ligne = $80)
        JSR     LCDOUT				* Envoi  l'afficheur
		
		JMP		M_V					* Saut  M_V
		
B_V		LDAB	#1					* Si bon vide, alors autorisation
		STAB	AUT_OUV				*    d'ouverture de la vanne (AUT_OUV=1)
		
		LDX		MSG3				* Message " Vide/pression ok "
		LDAB	#$80				* Chargement de l'adresse
		STAB 	LCDBAS				*    d'affichage (1 ligne = $80)
        JSR     LCDOUT				* Envoi  l'afficheur
		
		BRA		SORTIE				* Branchement  SORTIE

M_V		LDAB	#0					* Si mauvais vide, alors pas d'autorisation
		STAB	AUT_OUV				*    d'ouverture de la vanne (AUT_OUV=0)
		
		LDX		#PORTA				* Adresse du port A dans le registre X
		BCLR	0,X	00100000		* Fermeture autoritaire de la vanne (PA5=0)
		
		LDAB	#0					
		STAB 	UNE_FOIS			* UNE_FOIS=0: autorise l'appui sur BP ouverture
		CMPB	FLAGS				* Vrif. tat de FLAGS (indicateur de position de la vanne)
		BEQ		SORTIE				* Si FLAGS=0, la vanne est ferme, donc pas d'action compte
		JSR		DECADE				* Si FLAGS=1, la vanne est ouverte et la fermeture compte
        JSR     DELAY				* Dlai pour viter de compter 2 fermetures de vanne
		
SORTIE	RTS


*****************************************************************************	
*          Etat du contact  cl LOCAL/DISTANCE  
*****************************************************************************	
LOCAL_DISTANCE
		LDX		#PORTA				* Vrification de l'tat de PA2:
		LDAA	#04					*   si PA2=1 dfaut cl en LOCAL // si PA2=0, cl en DISTANCE
		BITA	0,X					* BITA: ET bit  bit, Z(CCR)=1 si rsultat du ET est nul (soit PA2=0)
		BEQ		DIST				* Si PA2 est  1, branchement  DIST (BEQ: test de Z du CCR, branch. si Z=1) 

		LDAB	#1					* Si cl en position LOCAL,
		STAB	LOC_DIS 			*    alors LOC_DIS=1
		
		LDX		#MSG6				* Message " LOCAL "
		LDAB    #$D4				* Chargement de l'adresse
		STAB 	LCDBAS				*    d'affichage (4 ligne = $D4)
        JSR     LCDOUT				* Envoi  l'afficheur
		
		JMP		SALUT				* Saut  SALUT
		
DIST	LDAB	#0					* Si cl en position DISTANCE,
		STAB	LOC_DIS 			*    alors LOC_DIS=0
		
		LDX		MSG5				* Message " DISTANCE "
		LDAB	#$D4				* Chargement de l'adresse
		STAB 	LCDBAS				*    d'affichage (1 ligne = $D4)
        JSR     LCDOUT				* Envoi  l'afficheur

SALUT	RTS
		

*****************************************************************************	
*          Nombre de cycles de fonctionnement de la vanne  
*****************************************************************************		
DURVIE
		LDX		MSG7				; Message " Nbre cycles "
		LDAB	#$94				; Initialise position ligne afficheur (3 ligne = $94)
		STAB 	LCDBAS				; Ecrire  partir de cette position
        JSR     LCDOUT				; Envoi le message vers l'afficheur
		LDD		COUNT				; Charge valeur du compteur	
		PSHA
		PSHB
		TBA
		JSR		CONVAFF				; Conversion Hexadcimal
		STD		VALLSB				; Sauvegarde la valeur convertie du poids faible compteur (LSB du Registre D)
		LDD		COUNT				; Charge valeur du compteur	
		JSR		CONVAFF				; Conversion Hexadcimal
		STD		VALMSB				; Sauvegarde la valeur convertie du poids fort compteur (MSB du Registre D)
		TBA
		JSR		CONVDECASC			; Conversion Dcimal-ASCII vers afficheur
		LDD		VALLSB				; Chargement valeur LSB dans le registre D
		TBA
		JSR		CONVDECASC			; Conversion Dcimal-ASCII vers afficheur
		PULB						; Retourne la valeur du compteur avant conversion LSB registre D
		PULA						; Retourne la valeur du compteur avant conversion MSB registre D
		RTS
		
		
*****************************************************************************	
*          Convertisseur HEX-Dcimal du compteur de cycles  
*****************************************************************************				
CONVAFF
		TSX
		DEX
		DEX
		TAB
		CLRA
		STAA	0,X
		INCA						
HEXDC0	PSHA
		LSRB
		BCC		HEXDC1
		ADDA	0,X
		DAA
		STAA	0,X
HEXDC1	PULA
		PSHB
		TAB
		ABA
		PULB
		DAA
		BCS		FINIT
		CMPB	#0
		BNE		HEXDC0				
FINIT	LDAB	0,X			
		CLRA
		STA		MSB
		STB		LSB
		LDAB	LSB
		LDAA	MSB
	
		RTS
		RTS							
	
	
*****************************************************************************	
*          Conversion Dcimal-ASCII pour afficheur LCD 
*****************************************************************************			
CONVDECASC		
		PSHA    
        ANDA	#$%11110000			; Conversion Dcimal-ASCII du poids fort MSB registre A pour l'afficheur
		LSRA
		LSRA
		LSRA
		LSRA
		ADDA	#$30
		LDAB	#$$94+#14			; Position d'affichage (dbut 3 ligne = $94)
		STAB    LCDBAS				; Validation position d'affichage
		JSR		TEMPO
		STAA    LCDBAS+1			; write data to lcd output port
		PULA
		
		ANDA	#$%00001111			; Conversion Dcimal-ASCII du poids faible LSB registre B pour l'afficheur
		ADDA	#$30
		LDAB	#$$94+#15			; Position d'affichage
		STAB    LCDBAS				; Validation position d'affichage
		
		JSR		TEMPO
		STAA	LCDBAS+1			; write data to lcd output port
		
        RTS
		RTS
		
		
*****************************************************************************	
*          Envoi des informations vers l'afficheur 
*****************************************************************************				
LCDOUT
		JSR     TEMPO
		LDAA    0,X
		CMPA	#NULL
		BEQ		FINCA
		INX
		PSHX
        STAA    LCDBAS+1			; write data to lcd output port
		PULX
		BRA		LCDOUT
FINCA	NOP
		RTS
		
		
*****************************************************************************	
*          Configuration de l'afficheur 
*****************************************************************************				
LCDSET
		LDAA	#$3C				; $3C valid pour un afficheur 4x20 ou $38 pour un afficheur 2x16
		STAA    LCDBAS
		JSR     DELAY
		LDAA	#$01				; Effacement de l'afficheur et mise en position Home du curseur
		STAA    LCDBAS
		JSR     DELAY
		LDAA	#$06				; Met l'afficheur en position On Display
		STAA    LCDBAS
		JSR     DELAY
		LDAA	#$0C				; Dplacement du curseur activ
		STAA    LCDBAS
		LDAA	#$01				; Dplacement du curseur sur la gauche
		STAA    LCDBAS
		LDAA	#$02				; Dplace le curseur en position Home
		STAA    LCDBAS
		JSR     DELAY
		RTS

			
*****************************************************************************	
*          Boucle d'attente Clavier 
*****************************************************************************			
DELAY
		PSHB						; Sauvegarde les registres
		PSHA
        LDAB    #$F0				; Activation de la boucle compteur 1
DEL1    LDAA    #$F0				; Activation de la boucle compteur 2
DEL2	DECA						; Dcrmente le compteur 2
		BNE		DEL2				; Branchement si non gal  0
		DECB						; Dcrmente le compteur 1
		BNE		DEL1				; Branchement si non gal  0
		PULA						; Restaure les registres
		PULB
		RTS
		
			
*****************************************************************************	
*          Boucle d'attente Afficheur 
*****************************************************************************			
TEMPO
		PSHB						; Sauvegarde les registres
		PSHA
        LDAB    #$16				; Activation de la boucle compteur 1
TEMP1   LDAA    #$16				; Activation de la boucle compteur 2
TEMP2	DECA						; Dcrmente le compteur 2
		BNE		TEMP2				; Branchement si non gal  0
		DECB						; Dcrmente le compteur 1
		BNE		TEMP1				; Branchement si non gal  0
		PULA						; Restaure les registres
		PULB
		RTS
				
				
*****************************************************************************	
*          Configuration clavier 
*****************************************************************************		
KEYSET
        LDAA    #IO 				;  Rcupre la valeur de configuration du clavier
        STAA    KEYBAS+3			; Validation de l'adresse clavier
        RTS
